package com.jeeplus.modules.supply.stockOut.service;

import com.jeeplus.common.utils.StringUtils;
import com.jeeplus.core.persistence.Page;
import com.jeeplus.core.service.CrudService;
import com.jeeplus.modules.supply.stockOut.entity.SupplyStockOut;
import com.jeeplus.modules.supply.stockOut.mapper.SupplyStockOutMapper;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Iterator;
import java.util.List;

/**
 * @author: 徐滕
 * @create: 2022-02-25 10:31
 **/
@Service
@Transactional(readOnly = true)
public class SupplyStockOutService  extends CrudService<SupplyStockOutMapper, SupplyStockOut> {

    @Override
    public Page<SupplyStockOut> findPage(Page<SupplyStockOut> page, SupplyStockOut supplyStockOut) {
        return super.findPage(page, supplyStockOut);
    }











    /**
     * 导入人工维护Excel数据
     * @param handmadeVindicateList
     * @return
     */
    @Transactional(readOnly = false)
    public String disposeHandmadeVindicateInfo(List<SupplyStockOut> handmadeVindicateList){
        Iterator<SupplyStockOut> it = handmadeVindicateList.iterator();
        //删除项目编号为空的数据信息
        while(it.hasNext()){
            SupplyStockOut info = it.next();
            if(StringUtils.isBlank(info.getProjectDefinition())){//判定项目定义号是否为空，为空则删除该条记录
                it.remove();
            }else{
                info.preInsert();//添加修改人和时间记录信息
            }
        }
        //批量修改(人工维护)
        modifyHandmadeVindicateList(handmadeVindicateList);
        return null;
    }


    /**
     * 批量修改手工上传数据信息
     * @param projectBasicsList
     * @return
     */
    @Transactional(readOnly = false)
    public String modifyHandmadeVindicateList(List<SupplyStockOut> projectBasicsList){
        //分批处理
        if(null!=projectBasicsList && projectBasicsList.size()>0){
            int pointsDataLimit = 100;//限制条数
            Integer size = projectBasicsList.size();
            //判断是否有必要分批
            if(pointsDataLimit<size){
                int part = size/pointsDataLimit;//分批数
                //
                for (int i = 0; i < part; i++) {
                    //100条
                    List<SupplyStockOut> listPage = projectBasicsList.subList(0, pointsDataLimit);
                    mapper.insertList(listPage);
                    //剔除
                    projectBasicsList.subList(0, pointsDataLimit).clear();
                }
                if(!projectBasicsList.isEmpty()){
                    mapper.insertList(projectBasicsList);
                }
            }else{
                mapper.insertList(projectBasicsList);
            }
        }
        return null;
    }
}
